<?php

// QuickTalk 2.1 build:20090819

class cFLD
{

var $id = '';     // field key (can be "emails_i")
var $uid = '';    // field source ("emails")
var $sort = false;// default sort order (ASC,DESC,FALSE)
var $name = '';   // field translation
var $desc = '';   // description (is used to store style/class info)
function cFLD($id,$name)
{
  $this->id = $id;
  $this->uid = ( substr($id,-2,2)=='_i' ? substr($id,0,-2) : $id );
  $this->name = $name;
}

}

// ----------------

class cSYS
{

// -- Properties --

var $sections; // list of sectionstitles (translated) visible for the current user ($oVIP->role)
var $types;    // list of types
var $statuses; // list of statuses
var $topics;   // count topics
var $replies;  // count replies
var $members;  // count members
var $states;   // other info
var $output;   // output media (screen,print)

// -- Constructor --

function cSYS()
{
  // Construct if not yet registered

  if ( !isset($_SESSION[QT]['sys_sections']) ) { global $oVIP; $_SESSION[QT]['sys_sections'] = GetSectionTitles($oVIP->role,-1,-1,'',QTF_SHOW_DOMAIN); }
  if ( !isset($_SESSION[QT]['sys_topics']) ) $_SESSION[QT]['sys_topics'] = $this->SysCount('topics');
  if ( !isset($_SESSION[QT]['sys_replies']) ) $_SESSION[QT]['sys_replies'] = $this->SysCount('replies');
  if ( !isset($_SESSION[QT]['sys_members']) ) $_SESSION[QT]['sys_members'] = $this->SysCount('members');
  if ( !isset($_SESSION[QT]['sys_states']) ) $_SESSION[QT]['sys_states'] = $this->SysCount('states');

  // Exit

  $this->types = $this->GetTypes();
  $this->statuses = $this->GetStatuses();
  $this->sections = $_SESSION[QT]['sys_sections'];
  $this->members = $_SESSION[QT]['sys_members'];
  $this->states = $_SESSION[QT]['sys_states'];
  $this->topics = $_SESSION[QT]['sys_topics'];
  $this->replies = $_SESSION[QT]['sys_replies'];
  $this->members = $_SESSION[QT]['sys_members'];
  $this->output = 'screen';
}

// --------

function SysCount($strObject='topics')
{
  if ( !is_string($strObject) ) die('SysCount: Invalid argument type (expect string)');

  // Process
  
  global $oDB;
  switch($strObject)
  {
  case 'topics':
    $oDB->Query('SELECT count(id) as countid FROM '.TABTOPIC);
    $row = $oDB->Getrow();
    return intval($row['countid']);
    break;
  case 'replies':
    $oDB->Query('SELECT count(id) as countid FROM '.TABPOST.' WHERE type<>"P"');
    $row = $oDB->Getrow();
    return intval($row['countid']);
    break;
  case 'messages':
    $oDB->Query('SELECT count(id) as countid FROM '.TABPOST);
    $row = $oDB->Getrow();
    return intval($row['countid']);
    break;
  case 'members':
    $oDB->Query('SELECT count(id) as countid FROM '.TABUSER);
    $row = $oDB->Getrow();
    return intval($row['countid']);
    break;
  case 'states':
    $arr = array();
      $oDB->Query('SELECT max(id) as countid FROM '.TABUSER);
      $row = $oDB->Getrow();
    $arr['newuserid'] = intval($row['countid']);
      $oDB->Query('SELECT name,firstdate FROM '.TABUSER.' WHERE id='.$row['countid'] );
      $row = $oDB->Getrow();
    $arr['newusername'] = $row['name'];
    $arr['newuserdate'] = (empty($row['firstdate']) ? '0' : substr($row['firstdate'],0,8)); // date only
    return $arr;
    break;
  }
}

// --------

function GetStatuses()
{
  global $L;
  return array('0'=>$L['Opened'],'1'=>$L['Closed']);
}

// --------

function GetTypes()
{
  global $L;
  return array('T'=>array('name'=>$L['Topic'],'color'=>''),'A'=>array('name'=>$L['News'],'color'=>''));
}

// --- [i] ---

function Changed()
{
  // increment and save in TAB SETTING

  if ( isset($_SESSION[QT]['sys_change']) ) {
  if ( $_SESSION[QT]['sys_change']!='-1' ) {
    global $oDB;
    $_SESSION[QT]['sys_change']=intval($_SESSION[QT]['sys_change'])+1; if ( $_SESSION[QT]['sys_change']>9 ) $_SESSION[QT]['sys_change']=0;
    $oDB->Query( 'UPDATE '.TABSETTING.' SET setting="'.$_SESSION[QT]['sys_change'].'" WHERE param="sys_change"' );
  }}
}

// --- [i] ---

function SetLang($str='en')
{
  if ( !is_string($str) ) die('cSYS->SetLang: Argument #1 must be a string');
  if ( empty($str) ) die('cSYS->SetLang: Argument #1 must be a string');

  // check that value is valid (to avoid injection)
  require_once('bin/qtf_lang.php');
  if ( array_key_exists($str,$arrLang) )
  {
    $_SESSION[QT]['lang_iso'] = $str;
    $_SESSION[QT]['language'] = 'language/'.$arrLang[$str][2];
    if ( isset($_SESSION['L']) ) $_SESSION['L'] = array();
    if ( isset($_SESSION[QT]['sys_sections']) ) unset($_SESSION[QT]['sys_sections']);
    if ( isset($_SESSION[QT]['sys_statuses']) ) unset($_SESSION[QT]['sys_statuses']);
  }
  else
  {
    global $error;
    $error = 'Wrong iso code language';
  }
}

// --------

}

?>